## START: Set by rpmautospec
## (rpmautospec version 0.3.0)
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global version 0.11.2
%global reponame WasmEdge
%global capi_soname 0
%global capi_version 0.0.1

Name:    wasmedge
Version: %{version}
Release: %autorelease
Summary: High performance WebAssembly Virtual Machine
# The entire source code is ASL 2.0 except LICENSE.spdx which is CC0
License: ASL 2.0 and CC0
URL:     https://github.com/%{reponame}/%{reponame}
Source0: %{url}/releases/download/%{version}/%{reponame}-%{version}-src.tar.gz
BuildRequires: boost-devel
BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: git
BuildRequires: lld-devel
BuildRequires: llvm-devel
BuildRequires: ninja-build
BuildRequires: spdlog-devel
Requires:      lld
Requires:      llvm
Requires:      spdlog
# Currently wasmedge could only be built on specific arches
ExclusiveArch: x86_64 aarch64
Provides: %{reponame} = %{version}-%{release}
Provides: bundled(blake3) = 1.2.0
Provides: bundled(wasi-cpp-header) = 0.0.1
Provides: wasm-library

%description
High performance WebAssembly Virtual Machine

%package devel
Summary: %{reponame} development files
Requires: %{name}%{?_isa} = %{version}-%{release}
Provides: %{reponame}-devel = %{version}-%{release}

%description devel
This package contains necessary header files for %{reponame} development.

%prep
%autosetup -n %{name}
[ -f VERSION ] || echo -n %{version} > VERSION

%build
%cmake -GNinja -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBUILD_SHARED_LIBS=OFF -DWASMEDGE_BUILD_TESTS=OFF
%cmake_build

%install
%cmake_install
mv %{buildroot}%{_libdir}/%{name}/lib%{name}Plugin%{reponame}Process.so %{buildroot}%{_libdir}/%{name}/lib%{name}Plugin%{reponame}Process.so.%{version}
ln -s lib%{name}Plugin%{reponame}Process.so.%{version} %{buildroot}%{_libdir}/%{name}/lib%{name}Plugin%{reponame}Process.so

%files
%license LICENSE LICENSE.spdx
%doc Changelog.md README.md SECURITY.md
%{_bindir}/wasmedge
%{_bindir}/wasmedgec
%{_libdir}/lib%{name}.so.%{capi_version}
%{_libdir}/lib%{name}.so.%{capi_soname}
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/lib%{name}Plugin%{reponame}Process.so.%{version}

%files devel
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/enum.inc
%{_includedir}/%{name}/enum_configure.h
%{_includedir}/%{name}/enum_errcode.h
%{_includedir}/%{name}/enum_types.h
%{_includedir}/%{name}/int128.h
%{_includedir}/%{name}/version.h
%{_includedir}/%{name}/wasmedge.h
%{_libdir}/lib%{name}.so
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/lib%{name}Plugin%{reponame}Process.so

%changelog
* Fri Nov 04 2022 dm4 <dm4@secondstate.io> 0.11.2-1
- Release 0.11.2

* Thu Nov 03 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> 0.11.1-2
- Provides: wasm-library

* Fri Oct 21 2022 dm4 <dm4@secondstate.io> 0.11.1-1
- Release 0.11.1

* Wed Aug 31 2022 dm4 <dm4@secondstate.io> 0.11.0-1
- Release 0.11.0

* Mon Aug 01 2022 dm4 <dm4@secondstate.io> 0.10.1-1
- Initial import (fedora#2035222).
